写在前边

链接:Codeforces Global Round 13

\(A,B,C,D\)

A. K-th Largest Value

链接:A题链接

题目大意:

有一个字串只由\(0、1\)组成,有两个操作,\(1\)是让其中\(a_x\)变为\(1-a_x\),\(2\)是询问数组中第\(k\)大的数。

思路:

很简单了,字串中元素只在\(0、1\)中变化,要问第\(k\)大的数字,那么非\(1\)即\(0\),就用一个\(map\)维护\(0,1\)的数量就好了

代码:

#include <iostream>
#include <cstring>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring> //#pragma GCC optimize(2)
//#pragma GCC optimize(3,"Ofast","inline") using namespace std; #define Inf 0x3f3f3f3f
#define PII pair<int, int>
#define P2LL pair<long long, long long>
#define endl '\n' typedef long long LL;
typedef unsigned long long ULL;
typedef vector<long long> VLL;
typedef vector<int> VI; const int Mod = 10000007; const int N = 1E5 + 10;
int a[N]; void solve() {
int n, q;
scanf("%d%d", &n, &q);
map<int, int> cnt;
for (int i = 1; i <= n; i++) {
scanf("%d", &a[i]);
cnt[a[i]]++;
}
while (q--) {
int t, x;
scanf("%d%d", &t, &x);
if (t == 1) {
if (a[x] == 1) {
a[x] = 0;
cnt[0]++, cnt[1]--;
} else {
a[x] = 1;
cnt[1]++, cnt[0]--;
}
} else if (t == 2) {
if (cnt[1] >= x) puts("1");
else puts("0");
}
}
} int main()
{
//ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
solve();
return 0;
}

B. Minimal Cost

链接:B题链接

题目大意:

每行一个箱子,第\(i\)行箱子的坐标为\(a_i\),你的任务就是推箱子,然后把利用最小的花费把开一条路使得你可以从左上角走到右下角。

思路:

注意

  1. 每行就一个!
  2. 你可以随便方向的走!

    那么这样就很简单了,只需要在一列箱子中开一个口就好了,然后不断更新答案即可。

代码:

#include <iostream>
#include <cstring>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring> //#pragma GCC optimize(2)
//#pragma GCC optimize(3,"Ofast","inline") using namespace std; #define Inf 0x3f3f3f3f
#define PII pair<int, int>
#define P2LL pair<long long, long long>
#define endl '\n' typedef long long LL;
typedef unsigned long long ULL;
typedef vector<long long> VLL;
typedef vector<int> VI; const int Mod = 10000007; const int N = 110;
int a[N]; void solve() {
int n, u, v;
scanf("%d%d%d", &n, &u, &v);
for (int i = 1; i <= n; i++) scanf("%d", &a[i]); int res = 2e9 + 10;
for (int i = 2; i <= n; i++) {
if (abs(a[i] - a[i - 1]) > 1) res = 0;
if (a[i] == a[i - 1]) res = min(res, v + min(v, u));
if (abs(a[i] - a[i - 1]) == 1) res = min(res, min(v, u));
} printf("%d\n", res);
} int main()
{
//ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
int t;
scanf("%d", &t);
while (t--) {
solve();
} return 0;
}

C. Pekora and Trampoline

链接:C题链接

题目大意:

跳床,有\(n\)个跳床,床的高度为\(s_i\),每在上边跳一次那么\(s_i\)减小\(1\),每次跨越着跳,当前在\(i\)那么一步会跳到\(i + s_i\)去,每次可以从任意一个跳床开始跳,直到跳出所有跳床算一次操作,那么经过多少次操作,所有的\(s_i\)都变为\(1\),注意已经变为\(1\)的床不会再减小。

思路:

贪心的想,假如我们要是所有的床都变为\(1\),那么我们每次一定得从最左边跳到最右边,所以不如直接贪心加模拟的方法解题。

1.维护一个\(p\)数组,\(p_i\)表示已经在第\(i\)张床上跳了\(p_i\)次。

2.更新答案\(res += max(0, s[i] - p[i] - 1)\),即如果\(s[i] - 1 > p[i]\)说明还需要在第i张床上跳\(s[i] - p[i] - 1\)次,如果\(s[i] - 1 \leq p[i]\),那么说明第\(i\)张床上\(s[i]\)已经变为\(1\)。同时如果在第i张床上跳,因为\(s[i]\)每次减一,直到减法为\(1\)(\(s[i] = 1\)就没必要跳了),那么会影响后边第\(i + s[i], ...,i + 2\)床。

3. 还有就是,如果第\(i\)张床上跳的过多,即\(s[i]\)已经变为\(1\)了,那么第\(i\)张床上多余的跳跃次数可以转移到下一张床上。

代码:

#include <iostream>
#include <cstring>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring> //#pragma GCC optimize(2)
//#pragma GCC optimize(3,"Ofast","inline") using namespace std; #define Inf 0x3f3f3f3f
#define PII pair<int, int>
#define P2LL pair<long long, long long>
#define endl '\n' typedef long long LL;
typedef unsigned long long ULL;
typedef vector<long long> VLL;
typedef vector<int> VI; const int Mod = 10000007; LL gcd(LL a, LL b) {
return b ? gcd(b, a % b) : a;
} const int N = 5010;
int s[N];
int p[N]; void solve() {
int n;
scanf("%d", &n);
for (int i = 1; i <= n; i++) scanf("%d", &s[i]); LL res = 0;
memset(p, 0, sizeof p);
for (int i = 1; i <= n; i++) {
int x = max(0, s[i] - p[i] - 1);
res += x;
for (int j = i + 2; j <= min(n, i + s[i]); j++) {
p[j]++;
}
p[i + 1] += max(p[i] - s[i] + 1, 0);
}
printf("%lld\n", res);
} int main()
{
//ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
int t;
scanf("%d", &t);
while (t--) {
solve();
}
return 0;
}

D. Zookeeper and The Infinite Zoo

链接:D题链接

题目大意:

可以在结点\(u\)到\(u+v\)连一条边,当前仅当\(u \, \& \, v = v\)的时候,然后给定\(q\)个询问,每次两个端点\(u_i\), \(v_i\)问是否能从\(u_i\)到\(v_i\)。

思路:

首先发现两个性质:

  1. 假如现结点为\(v\),那么它一定可以转移到\(2 * v\),很显然。
  2. 还有就是要满足\(u \, \& \, v = v\),那么起码满足\(u \leq v\),否则直接\(pass\)掉即可

然后再推到发现,\(u\)中\(1\)的个数必须要大于等于\(v\)中\(1\)的个数,为什么呢?

我们令\(k = v - u\).

我们发现,因为\(u \, \& \, k = k\),那么说明,\(u\)与\(k\)的二进制数中存在\(1\)的位数一定在同一位啊,否则不可能按位与得到\(k\),然后实现\(u\)转移到\(u+k = v\),那么\(v\)相对于\(u\)来说肯定是\(u\)其中的某些\(1\)进位才得到了\(u+k = v\),那么所以说\(v\)中\(1\)得个数肯定是小于等于\(u\)中\(1\)得个数的,举两个例子:

\(u_(2) = 011\), \(k_(2) = 001\),那么\(v_(2) = 100\)。\(1\)的个数减少了。

\(u_(2) = 011\), \(k_(2) = 011\),那么\(v_(2) = 110\)。\(1\)的个数不变。

那么单纯满足这个条件就对了吗,当然不是。

还要满足,\(v\)中的每一位\(1\)要高于\(u\)中每一位的\(1\),总不能越转移越低吧。那么满足这两个条件,\(u\)到\(v\)就可以进行转移了,那么上边的操作都可以用\(lowbit\)运算就可以了

代码:

#include <iostream>
#include <cstring>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <cstring> //#pragma GCC optimize(2)
//#pragma GCC optimize(3,"Ofast","inline") using namespace std; #define Inf 0x3f3f3f3f
#define PII pair<int, int>
#define P2LL pair<long long, long long>
#define endl '\n'
#define pub push_back
#define pob pop_back typedef long long LL;
typedef unsigned long long ULL;
typedef vector<long long> VLL;
typedef vector<int> VI; const int Mod = 10000007; int lowbit(int x) {
return x & (-x);
} void solve() {
int u, v;
scanf("%d%d", &u, &v); if (u > v) {
puts("NO");
return;
}
int uu = u, vv = v;
int cnt1 = 0, cnt2 = 0;
while (uu) { //u中1的个数
uu -= lowbit(uu);
cnt1++;
}
while (vv) { //v中1的个数
vv -= lowbit(vv);
cnt2++;
}
while (u && v) { //必须往高位推才行
if (lowbit(u) > lowbit(v)) {
puts("NO");
return;
}
u -= lowbit(u), v -= lowbit(v);
}
if (cnt1 >= cnt2) puts("YES");
else puts("NO");
} int main()
{
//ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
int t;
scanf("%d", &t);
while (t--) {
solve();
} return 0;
}

Codeforces Global Round 13 A-D题题解的更多相关文章

  1. Codeforces Global Round 13

    比赛地址 A(水题) 题目链接 题目: 给出一个\(01\)序列,有2种操作:1.将某个位置取反:2.询问\(01\)序列中第\(k\)大的数 解析: 显然维护1的数目即可 #include<b ...

  2. Codeforces Global Round 11 个人题解(B题)

    Codeforces Global Round 11 1427A. Avoiding Zero 题目链接:click here 待补 1427B. Chess Cheater 题目链接:click h ...

  3. Codeforces Global Round 2 题解

    Codeforces Global Round 2 题目链接:https://codeforces.com/contest/1119 A. Ilya and a Colorful Walk 题意: 给 ...

  4. Codeforces Global Round 1 (A-E题解)

    Codeforces Global Round 1 题目链接:https://codeforces.com/contest/1110 A. Parity 题意: 给出{ak},b,k,判断a1*b^( ...

  5. Codeforces Global Round 1 (CF1110) (未完结,只有 A-F)

    Codeforces Global Round 1 (CF1110) 继续补题.因为看见同学打了这场,而且涨分还不错,所以觉得这套题目可能会比较有意思. 因为下午要开学了,所以恐怕暂时不能把这套题目补 ...

  6. Codeforces Beta Round #13 C. Sequence (DP)

    题目大意 给一个数列,长度不超过 5000,每次可以将其中的一个数加 1 或者减 1,问,最少需要多少次操作,才能使得这个数列单调不降 数列中每个数为 -109-109 中的一个数 做法分析 先这样考 ...

  7. CodeForces Global Round 1

    CodeForces Global Round 1 CF新的比赛呢(虽然没啥区别)!这种报名的人多的比赛涨分是真的快.... 所以就写下题解吧. A. Parity 太简单了,随便模拟一下就完了. B ...

  8. Codeforces Global Round 1 - D. Jongmah(动态规划)

    Problem   Codeforces Global Round 1 - D. Jongmah Time Limit: 3000 mSec Problem Description Input Out ...

  9. 【手抖康复训练1 】Codeforces Global Round 6

    [手抖康复训练1 ]Codeforces Global Round 6 总结:不想复习随意打的一场,比赛开始就是熟悉的N分钟进不去时间,2333,太久没写题的后果就是:A 题手抖过不了样例 B题秒出思 ...

  10. Codeforces Global Round 17

    Codeforces Global Round 17 A. Anti Light's Cell Guessing 坑点:\(n=1,m=1\) 时答案为 \(0\) . 其他情况:当 \(n=1\) ...

随机推荐

  1. 2021-7-6 VUE笔记

    v-cloak:使用的display:none: 直到编译完成后开始显示: v-text和插值表达式,非必要响应式用v-text会比较好,使用插值表达式要加上v-cloak; v-html:不推荐使用 ...

  2. python 镜像

    https://pypi.douban.com/simple/   豆瓣源 pip install -i https://pypi.douban.com/simple/ pymysql # pymys ...

  3. CGLIB动态代理对象GC问题排查

    一.问题是怎么发现的 最近有个新系统开发完成后要上线,由于系统调用量很大,所以先对核心接口进行了一次压力测试,由于核心接口中基本上只有纯内存运算,所以预估核心接口的压测QPS能够达到上千. 压测容器配 ...

  4. windows配置supervisor实现nginx自启

    前言 有些老项目的nginx部署在windows server上,而且服务器比较老旧,经常异常重启.鉴于个人并不熟悉windows server,因此配置supervisor自启nginx,实现win ...

  5. linux设置信号量系统参数

    前言 信号量是IPC(进程间通信)机制的一种,用于协调多个进程或线程对共享数据的读写操作,本质上是一个计数器.类似于锁,主要用于保护共享资源,控制同时访问资源的进程数. 信号量只允许调用者对它进行等待 ...

  6. redis开启多线程

    在Redis 6.0中,非常受关注的第一个新特性就是多线程. 在Redis 6.0中,多线程默认是禁用的,只使用主线程.如果需要使用多线程功能,需要在 redis.conf文件中进行配置(重启服务). ...

  7. API接口的设计思路

    ​ API接口设计是软件开发中非常重要的一环,良好的设计规范能够提高开发效率.减少问题和错误,并增强系统的可维护性和可扩展性.本文从程序员的视角,讨论一些常见的API接口设计规范. 一.遵循RESTf ...

  8. 小红书获得小红书笔记详情 API 返回值说明

    ​ item_get_video-获得小红书笔记详情  注册开通 smallredbook.item_get_video 公共参数 名称 类型 必须 描述 key String 是 调用key(必须以 ...

  9. PHP上传文件$_FILES, $_POST为空 empty 时, 文件上传大小限制

    原因 今天在使用ci upload库时, 上传mp4发现表单为空, 上传png等类型却可以正常. 折腾一番后才恍然, PHP上传大小限制的问题. Make一下. 真是失策啊, 一开始我还不相信到处瞎折 ...

  10. 在Go中如何实现并发

    Go语言的并发机制是其强大和流行的一个关键特性之一.Go使用协程(goroutines)和通道(channels)来实现并发编程,这使得编写高效且可维护的并发代码变得相对容易.下面是Go的并发机制的详 ...